/*
 *  suchar1.c -- demonstrace problmu signed/unsigned char
 *
 *  UPOZORNN: pouze pro BC 3.1 -- pouv #pragma
 *
 *  problm:  implicitn konverze   char --> int
 *
 *        char   ------->   int
 *     ===========================
 *     signed char       -128..127
 *     unsigned char        0..255
 *
 *  porovnn znak (po konverzi, kter probhne vdy) dv rzn vsledek
 *
 *  EEN: explicitn petypovat char na signed char nebo unsigned char
 *
 */

#ifndef __TURBOC__
# error "Pouijte Borland C"
#endif

#include <stdio.h>

/**************************************************************************/

#pragma option -K                /* implicitn unsigned char (BC 3.1) */

int Cmp1(const char c1, const char c2) {
  if(c1 == c2) return 0; /* shoda */
  return (c1 > c2) ? 1 : -1;
}

#pragma option -K-               /* implicitn signed char (BC 3.1) */

int Cmp2(const char c1, const char c2) {
  if(c1 == c2) return 0; /* shoda */
  return (c1 > c2) ? 1 : -1;
}

/**************************************************************************/

#define TEST(a,b) \
        printf(#a " " #b "  %d  %d \n", Cmp1(a,b), Cmp2(a,b));

int main(void)
{
  printf("Test:\n");
  TEST('','');        /* shoda je v podku vdy */
  TEST('A','A');

  TEST('A','');        /* rzn vsledky porovnn! */
  TEST('','A');

  return 0;
}

