// stl-sort-vector.cc
// pklad pouit algoritmu sort

#include <vector>      // vector
#include <algorithm>   // sort, copy
#include <iostream>    // cin, cout
#include <iterator>    // ostream_iterator

typedef std::vector<int>            vec_t;
typedef std::ostream_iterator<int>  outiter_t;

int main() {
#if 1
  const int SIZE = 5;
  static int a[SIZE] = { 4, 2, 5, 1, 3 };
  vec_t v(SIZE);  // vektor ze zadanou velikost
  std::copy(a, a+SIZE, v.begin() );   // kopie
#else
  int i;
  vec_t v;  // nulov velikost
  while ( std::cin >> i ) // ten
    v.push_back(i);       // vektor se zvtuje
#endif
  std::sort(v.begin(), v.end());      // azen
  outiter_t o(std::cout, "\n");       // itertor
  std::copy(v.begin(), v.end(), o);   // tisk
}
