/*
   Subject: Re: kbhit() MSDOS equivalent in Linux

   test kbhit() a readch()

   zdroj: NetNews
*/


#include <stdio.h>
#include <ctype.h>
#include <termios.h>
#include <locale.h>

static struct termios orig, new;
static int peek = -1;

int main()
{
  int ch =0;

  setlocale(LC_CTYPE,""); /* localization for test */

  tcgetattr(0, &orig);
  new = orig;
  new.c_lflag &= ~ICANON;
  new.c_lflag &= ~ECHO;
  new.c_lflag &= ~ISIG;
  new.c_cc[VMIN] = 1;
  new.c_cc[VTIME] = 0;
  tcsetattr(0, TCSANOW, &new);

  printf("konec = klavesa q nebo ^D \n",ch);

  while(ch != 'q' && ch != '\004') {
    if(kbhit()) {
        ch = readch();
        if(isprint(ch))
          printf("klavesa: '%c'\n", ch);
        else
          printf("klavesa: '\\x%x'\n", ch);
    }
  }
  tcsetattr(0,TCSANOW, &orig);
  exit(0);
}


int kbhit()
{

  char ch;
  int nread;

  if(peek != -1) return 1;
  new.c_cc[VMIN]=0;
  tcsetattr(0, TCSANOW, &new);
  nread = read(0,&ch,1);
  new.c_cc[VMIN]=1;
  tcsetattr(0, TCSANOW, &new);

  if(nread == 1) {
   peek = ch;
   return 1;
  }

  return 0;
}

int readch()
{

  unsigned char ch;

  if(peek != -1) {
    ch = peek;
    peek = -1;
    return ch;
  }

  read(0,&ch,1);
  return ch;
}


