// file.cc -- prce se soubory a vjimkami

#include <cstdio>
#include <iostream>
using namespace std;

// nvrh vjimek nen dobr -- lep je vytvoit zvltn tdy

class FilePtr {
  FILE *p;
 public:
  FilePtr(const char *name, const char *atr) {
    p = fopen(name,atr);
    if(!p) {
      cout << "throw int(2)\n" ;
      throw int(2);
    }
    cout << "fopen\n";
  }
  ~FilePtr()  { 
    cout << "fclose\n";
    fclose(p); 
  }
  operator FILE*()  { return p; }
};

void use_file(const char *jmeno) {
  FilePtr f(jmeno,"r");
  // pouit souboru f
#if 1
  cout << "throw int(1)\n" ;
  throw int(1);
#endif
} // automaticky uzave soubor

int main() {
  try {
    use_file("file.cc");
  }
  catch(int i) {
    cout << "error: " << i << endl;
    exit(1);
  }
  return 0;
}
